//+------------------------------------------------------------------+
//|                                                    BandsIndi.mq4 |
//|                                         Copyright  2009, RoboFx |
//|                                             http://www.robofx.org|
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, RoboFx"
#property link "http://www.robofx.org"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LightBlue
#property indicator_color2 Magenta
#property indicator_color3 Tomato
//---- indicator parameters
extern double    M1=6;
extern double    M2=6;
extern int       N=25;
//---- buffers
double UpperBuffer[];
double MiddleBuffer[];
double LowerBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,UpperBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MiddleBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,LowerBuffer);
   
   SetIndexLabel(0,"Upper buffer");
   SetIndexLabel(1,"Middle buffer");
   SetIndexLabel(2,"Lower buffer");
//----
   IndicatorShortName("BandsIndi");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
{
   int    i,counted_bars=IndicatorCounted();
//----
   if(Bars<=N) return(0);
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
   {
      UpperBuffer[i]=(1+M1/100.0)*iMA(NULL,0,N,0,MODE_SMA,PRICE_CLOSE,i);
      LowerBuffer[i]=(1-M1/100.0)*iMA(NULL,0,N,0,MODE_SMA,PRICE_CLOSE,i);
   }
//----
   limit=Bars-counted_bars;
   for(i=0; i<limit; i++)
   {
      MiddleBuffer[i]=(UpperBuffer[i]+LowerBuffer[i])/2.0;
   }
//----
   return(0);
}
//+------------------------------------------------------------------+